/////////////////////Common sets_data

function load_data_set_to_table(data_set) {
    //////////show header
    $.each(data_set, function(key1, data) {
        var le = data.length;
        $.each(data, function(key2, val) {
            if (key1 == 0) {
                var width = parseInt(100 / le);
                $("#data_set_table thead tr").append(
                    '<th style="width:' + width + '%">' + key2 + "</th>"
                );
            }
        });
        show_table_header = false;
    });

    ////////////////// show data
    $.each(data_set, function(key1, data) {
        var row = "<tr>";
        $.each(data, function(key2, val) {
            row = row + "<td>" + val + "</td>";
        });
        row = row + "</tr>";

        $("#data_set_table tbody").append(row);
    });
}

var threshold_values = [];
var services_list = [];
var services_events = [];
var services_events_details = [];
var totalPositive = 0;
var totalNegative = 0;
var totalSensors = 3;
var fogNodes = 3;
var nodesWiseSensors = 0;
var nodeName = 'Fog Node ';

var newNodeWiseSensors = 1;
var NodeNumber = 1;

var allNodeWiseEntropy = [];


function solution_steps(data_set) {
    ///////////// collect Services names
    fogNodes = parseInt($("input[name='fogNodes']").val());

    $.each(data_set, function(index, values) {
        $.each(values, function(serviceName, serviceValue) {
            if (serviceName != "s_no") {
                services_list.push(serviceName);
            }
        });
        return false;
    });

    totalSensors = (data_set.length * services_list.length);
    nodesWiseSensors = Math.round((totalSensors / fogNodes));
    newNodeWiseSensors = nodesWiseSensors;

    ///////////// collect threshold values
    services_list.forEach(element => {
        var values_list = [];
        $.each(data_set, function(index, values) {
            $.each(values, function(serviceName, serviceValue) {
                if (serviceName != "s_no") {
                    if (serviceName == element) {
                        values_list.push(serviceValue);
                    }
                }
            });
        });
        var max = Math.max.apply(Math, values_list); // 3
        var min = Math.min.apply(Math, values_list);
        var mean = Math.floor((max + min) / 2)
        threshold_values.push({
            max: max,
            mean: mean,
            min: min
        });
    });


    var table = '<table class="table table-striped table-bordered"><thead>' +
        '<tr>' +
        '<th>S.no</th>' +
        '<th class="text-center">FOG Node</th>' +
        '<th>Services</th>' +
        '<th class="text-center">Sensing Value</th>' +
        '<th class="text-center">Threshold Values</th>' +
        '<th class="text-center">Event</th></tr>';
    table += '</thead><tbody>';
    var counter = 1;
    $.each(data_set, function(index, values) {
        $.each(values, function(indexInArray, valueOfElement) {
            if (indexInArray != 's_no') {
                var node = findNodeName(counter);
                console.log(navigator.hardwareConcurrency)
                table += '<tr>';
                table += '<td>' + counter + '</td>';
                table += '<td>' + node + '</td>';
                var obj = threshold_values[services_list.indexOf(indexInArray)];
                table += '<td>' + indexInArray + '</td>' +
                    '<td class="text-center">' + valueOfElement + '</td>' +
                    '<td class="text-center">' + obj.min + '&nbsp;&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;&nbsp;&nbsp;' + obj.mean + '&nbsp;&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;&nbsp;&nbsp;' + obj.max + '</td>';
                if (valueOfElement >= obj.mean) {
                    services_events.push({
                        "Service": indexInArray,
                        "FogNode": node,
                        "Event": 1
                    });
                    totalPositive++;
                    table += '<td class="text-center">1</td>';
                } else {
                    services_events.push({
                        "Service": indexInArray,
                        "FogNode": node,
                        "Event": 0
                    });
                    totalNegative++;
                    table += '<td class="text-center">0</td>';
                }
                table += '</tr>';
                counter++;
            }
        });
    });
    table += '</tbody></table><hr/>';

    $("#html_body").append(table);

    /////////////////////////////////////////////////////////////////Node Wise data
    var table = '<h3 class="text-center" style="background: #e6e6e6;">' + nodeName + ' Wise Data</h3><hr/>' +
        '<table class="table table-striped table-bordered"><thead>' +
        '<tr>' +
        '<th style="width:5%">S.no</th>' +
        '<th style="width:35%">' + nodeName + '</th>' +
        '<th style="width:20%" class="text-center">Total</th>' +
        '<th style="width:20%" class="text-center">Positive</th>' +
        '<th style="width:20%" class="text-center">Negative</th>';
    table += '</thead><tbody>';
    for (let index = 1; index <= fogNodes; index++) {
        var node = nodeName + index;
        var counterNodeWiseData = 0;
        var yes = 0;
        var no = 0;
        $.each(services_events, function(indexInArray, valueOfElement) {
            if (valueOfElement.FogNode != node)
                return;
            else {
                counterNodeWiseData++
                if (valueOfElement.Event == 1)
                    yes++
                    else
                        no++;
            }
        });
        table += '<tr>' +
            '<td>' + index + '</td>' +
            '<td>' + nodeName + index + '</td>' +
            '<td class="text-center">' + counterNodeWiseData + '</td>' +
            '<td class="text-center">' + yes + '</td>' +
            '<td class="text-center">' + no + '</td>' +
            '</tr>';

    }
    table += '</tbody></table><hr/>';
    $("#html_body").append(table);
    /////////////////////////////////////////////////////////////////Node Wise data

    ///////////////Calculate Entropy
    for (let index = 1; index <= fogNodes; index++) {
        var nodeNameCreated = nodeName + index;
        var table = '<h3 class="text-center" style="background: #e6e6e6;">' + nodeName + ' Wise Entropy</h3><hr/>' +
            '<h4 class="text-center" style="background: #e6e6e6;"><b>' + nodeNameCreated + '</b></h4>' +
            '<table class="table table-striped table-bordered"><thead>' +
            '<tr>' +
            '<th style="width:5%">S.no</th>' +
            '<th style="width:30%">Services</th>' +
            '<th style="width:15%" class="text-center">Events</th>' +
            '<th>Entropy</th>';
        table += '</thead><tbody>';


        calculateTotalPositiveAndNegative(services_events, services_list, nodeNameCreated, index);

        var serviceWiseEntropy = [];
        var icounter = 0;

        $.each(services_events_details, function(indexInArray, valueOfElement) {

            if (valueOfElement['FogNode'] != nodeNameCreated)
                return;

            var aa = (-valueOfElement['Positive']) / (valueOfElement['Positive'] + valueOfElement['Negative']);
            var bb = (valueOfElement['Positive']) / (valueOfElement['Positive'] + valueOfElement['Negative']);
            var cc = -(valueOfElement['Negative']) / (valueOfElement['Positive'] + valueOfElement['Negative']);
            var dd = (valueOfElement['Positive']) / (valueOfElement['Positive'] + valueOfElement['Negative']);

            var ee = Math.log(bb)
            var ff = Math.log(dd);

            var gg = aa * ee;
            var hh = cc * dd;

            var Ans = parseFloat((aa * hh).toFixed(3));

            serviceWiseEntropy.push({
                "Service": valueOfElement['Service'],
                "Positive": valueOfElement['Positive'],
                "Negative": valueOfElement['Negative'],
                "FogNode": nodeNameCreated,
                "Entropy": Ans,
            });
            table += "<tr>" +
                "<td>" + (indexInArray + 1) + "</td>" +
                "<td>" + valueOfElement['Service'] + "</td>" +
                "<td class='text-center'>[" + valueOfElement['Positive'] + "+," + valueOfElement['Negative'] + "-]</td>" +
                "<td>" + Ans + "</td>" +
                "</tr>";
            icounter = indexInArray + 1;
        });
        var totalEntropy = 0;
        $.each(serviceWiseEntropy, function(indexInArray, valueOfElement) {
            totalEntropy += valueOfElement.Entropy;
        });


        var averageEntropy = parseFloat((totalEntropy / serviceWiseEntropy.length).toFixed(3));
        table += "<tr>" +
            "<td>" + (icounter + 1) + "</td>" +
            "<th>Total</th>" +
            "<th class='text-center'>All Events</th>" +
            "<th>" + averageEntropy + "</th>" +
            "</tr>";
        table += '</tbody></table><hr/>';
        $("#html_body").append(table);
        allNodeWiseEntropy.push({
            "FogNode": nodeNameCreated,
            "AverageEntropy": averageEntropy,
        })

    }
    /////////////////////////////////////over All Entropy
    var allEntropyValues = 0;
    $.each(allNodeWiseEntropy, function(indexInArray, valueOfElement) {
        allEntropyValues += valueOfElement.AverageEntropy;
    });
    debugger
    var table = '<h3 class="text-center" style="background: #e6e6e6;">Over All Entropy: ' + (allEntropyValues / allNodeWiseEntropy.length) + '</h3><hr/>';
    $("#html_body").append(table);
    /////////////////////////////////////over All Entropy
}



function calculateTotalPositiveAndNegative(list, services, nodeNameCreated, index) {
    $.each(services, function(indexInArray, valueOfElement) {
        var positive = 0;
        var negative = 0;
        $.each(list, function(indexInArray1, valueOfElement1) {

            if (valueOfElement == valueOfElement1['Service'] && valueOfElement1['FogNode'] == nodeNameCreated) {
                if (valueOfElement1['Event'] == 0) {
                    negative++;
                } else {
                    positive++
                }
            }
        });

        services_events_details.push({
            "Service": valueOfElement,
            "Positive": positive,
            "Negative": negative,
            "FogNode": nodeNameCreated,
        });
    });

}



function findNodeName(counter) {

    if (counter > newNodeWiseSensors) {
        if (
            ((totalSensors / nodesWiseSensors) * nodesWiseSensors) > counter
        ) {
            NodeNumber++;
        }

        newNodeWiseSensors += nodesWiseSensors;
    }
    return nodeName + NodeNumber;
    // if (counter <= newNodeWiseSensors) {
    //     return nodeName + NodeNumber;
    // } else


}